//Copyright 2023 Hans Moeller. Licensed under the GNU GPL Version 3.
//
//
// This PTT project is distributed,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
// GNU General Public License for more details.


//#include <Keyboard.h>
#include <HID-Project.h>

int BTN_PTT = 9;  //PTT button
int BTN_MUTE = 8; // Mute button
int LED_PTT = 7;      //TX LED
int LED_MUTE = 6;
int SPEAKER = 5;

bool mute = false;

void setup()
{
  pinMode(BTN_PTT, INPUT);  // Set the button as an input
  digitalWrite(BTN_PTT, HIGH);  // Pull the button high

  pinMode(BTN_MUTE, INPUT);  // Set the button as an input
  digitalWrite(BTN_MUTE, HIGH);  // Pull the button high

  pinMode(LED_PTT, OUTPUT);
  pinMode(LED_MUTE, OUTPUT);
  pinMode(SPEAKER, OUTPUT);

  digitalWrite(LED_PTT, HIGH);  //Turn PTT LED off
  digitalWrite(SPEAKER, HIGH);  //Enable speaker

  Consumer.begin();

  delay (2000);   //Keyboard detection delay
  setMaxVolume();
}

void setMaxVolume(void){          //Set Android volume to max
  for (int i=0; i< 40;i++){
    Consumer.write(MEDIA_VOL_UP);
  }
   mute = false;
   digitalWrite(LED_MUTE, LOW);
}


void muteSpeaker(void){
    mute = true;
    digitalWrite(LED_MUTE, HIGH);
    digitalWrite(SPEAKER, LOW);
}

void unmuteSpeaker(void){
    mute = false;
   digitalWrite(LED_MUTE, LOW);
   digitalWrite(SPEAKER, HIGH);
}



void loop()
{
  if (digitalRead(BTN_PTT) == 0)  // if the button goes low
  {
    muteSpeaker();
    Keyboard.press(KEY_F12);
   
    while (digitalRead(BTN_PTT) == 0){
      delay(100);
      digitalWrite(LED_PTT, LOW);
      delay(100);
      digitalWrite(LED_PTT, HIGH);
    }

    Keyboard.release(KEY_F12);
    delay(300);  //debounce delay
    unmuteSpeaker();
  }

  if (digitalRead(BTN_MUTE) == 0 && mute == true){
    unmuteSpeaker();
    delay(500);  //debounce delay
  }  

  if (digitalRead(BTN_MUTE) == 0 && mute == false){
    muteSpeaker();
    delay(500);  //debounce delay
  }  



}

